#ifndef MISC_H_
#define MISC_H_

#include "common.h"
#include "macros.h"

struct buffer;
struct passwd;
struct group;

void message(int type, const char *filename, int line, const char *fmt, ...);
ssize_t write_full(int fd, const char *buf, size_t size);

ret_t open_file_ro(const char *file_name, int *fd);
ret_t close_file(int *fd);
ret_t file_length(int fd, size_t *length);
ret_t mmap_file(const int fd, void **mmap_addr, size_t length);
ret_t munmap_file(void **addr, const size_t length);
ret_t pipe_open(const char *file_name, int mode, int *fdres);

char *extract_string(struct buffer *buf, char *str, size_t max_len, size_t *_len, int delim);
int str_to_uint(const char *str, char **endptr, unsigned int *num, int base);
int xsnprintf(char *str, size_t size, const char *fmt, ...);
int mem_touch_and_lock(const void *addr, size_t len);

int ascii_to_hex(char c);
char hex_to_ascii(int value);

int str_isnumber(const char *str);
void sanitize_stdio();
void daemonize();
int getpw_by_name_or_uid(const char *name, struct passwd *pwd);
int getgr_by_name_or_gid(const char *name, struct group *grp);
char *canonize_path(const char *path);

#endif /* MISC_H_ */
